require_relative "../util/Comp"

module Callidus
    class KNN
        attr_accessor :input
        attr_accessor :output

        def initialize(ip = [], op = [])
            @input = ip
            @output = op
        end

        def predict(x, k = 1)
            diffs = @input.map { |i| Math.sqrt(x.each_with_index.map { |val, ind| (i[ind] - val) ** 2 }.sum) }
            tdiffs = diffs.dup

            mins = []

            k.times do |i|
                ind = tdiffs.index(tdiffs.min)
                mins << tdiffs[ind]
                tdiffs.pop(ind)
            end

            @output[diffs.index(Comp::Arrays.MostFrequent(mins))];
        end
    end
end